poj 3368 Frequent values

2024-04-29 13:38
文章标签 poj values 3368 frequent

本文主要是介绍poj 3368 Frequent values,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目链接:

点击打开链接


Description

You are given a sequence of n integers a1 , a2 , ... , an in non-decreasing order. In addition to that, you are given several queries consisting of indices i and j (1 ≤ i ≤ j ≤ n). For each query, determine the most frequent value among the integers ai , ... , aj.

Input

The input consists of several test cases. Each test case starts with a line containing two integers n and q (1 ≤ n, q ≤ 100000). The next line contains n integers a1 , ... , an (-100000 ≤ ai ≤ 100000, for each i ∈ {1, ..., n}) separated by spaces. You can assume that for each i ∈ {1, ..., n-1}: ai ≤ ai+1. The following q lines contain one query each, consisting of two integers i and j (1 ≤ i ≤ j ≤ n), which indicate the boundary indices for the 
query.

The last test case is followed by a line containing a single 0.

Output

For each query, print one line with one integer: The number of occurrences of the most frequent value within the given range.

Sample Input

10 3
-1 -1 1 1 1 1 3 10 10 10
2 3
1 10
5 10
0

Sample Output

1
4
3



题目大意: 给出非下降的序列,q次询问某个区间内数最多的值是多少数(比如在区间1-10内最多的是-1,有4个,则输出4)

思路: 离散化+RMQ,求离散后的最大值在对应到相应的区间上

#include <iostream>
#include<cstdio>
#include<cstring>
#include<cmath>using namespace std;int M[100000];///存线段树的节点
int A[100000];///存每个值的长度(相当于离散化)
int pre[100000];///存输入区间值所对应的离散后的区间
int l[100000];///每个值的左边界
int r[100000];///右边界
int a[100000];
int n,q;
int len;///长度
///建线段树
void build_RMQ(int node,int b,int e,int M[],int A[])
{if(b==e){M[node]=A[b];}else{build_RMQ(2*node,b,(b+e)/2,M,A);build_RMQ(2*node+1,(b+e)/2+1,e,M,A);if(M[2*node]>=M[2*node+1])M[node]=M[2*node];else M[node]=M[2*node+1];}
}
///查询线段树区间取最大值
int query(int node,int b,int e,int M[],int A[],int i,int j)
{int p1,p2;if(i>e||j<b)return -1;if(b>=i&&e<=j)return M[node];p1=query(2*node,b,(b+e)/2,M,A,i,j);p2=query(2*node+1,(b+e)/2+1,e,M,A,i,j);if(p1==-1)return p2;if(p2==-1)return p1;if(p1<=p2)return p2;return  p1;
}
int main()
{while(scanf("%d",&n)){memset(M,0,sizeof(0));if(!n)break;scanf("%d",&q);scanf("%d",&a[1]);memset(A,0,sizeof(A));len=1;A[len]=1;l[len]=1;pre[1]=len;for(int i=2; i<=n; i++){scanf("%d",&a[i]);if(a[i]==a[i-1]){A[len]++;pre[i]=len;}else{r[len]=i-1;len++;l[len]=i;pre[i]=len;A[len]=1;}//cout<<"**"<<endl;}//cout<<"#"<<A[1]<<" "<<A[2]<<endl;//r[len]=n;// cout<<len<<endl;/* for(int i=1;i<=len;i++){cout<<i<<" "<<A[i]<<endl;}*/build_RMQ(1,1,len,M,A);int u,v;while(q--){scanf("%d%d",&u,&v);int c=pre[u];int d=pre[v];int b=pre[u]+1;///把输入的区间去掉(因为不知道输入的///是否包含了该值的所有长度)int e=pre[v]-1;//<<b<<" "<<e<<endl;if(c==d){printf("%d\n",v-u+1);}///特殊情况处理else if(c+1==d){printf("%d\n",max(r[c]-u+1,v-l[d]+1));}else{int mx=query(1,1,len,M,A,b,e);//cout<<"mx:"<<mx<<endl;//cout<<"r[]:"<<r[pre[u]]<<endl;//cout<<"l[]:"<<l[pre[v]]<<endl;int k=r[pre[u]]-u+1;int h=v-l[pre[v]]+1;///在比较中间的最大长度的值和残余的两个边界的长度printf("%d\n",max(mx,max(k,h)));}}}return 0;
}



这篇关于poj 3368 Frequent values的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/946239

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i